; ----------------------------------------------------------------------
; DETECTA O MICROCONTROLADOR                                  18/07/2020
;
; STATUS: NAO FUNFOU ADEQUADAMENTE
;
; Detecta o microcontrolador que sera programado e o identifica no
; registrador 'microchip' com um dos seguintes codigos:
; 
; microchip = 0x82  --> 01.0000.010 --> PIC16F627A
;           = 0x83  --> 01.0000.011 --> PIC16F628A
;           = 0x88  --> 01.0001.000 --> PIC16F648A
;           = 0x00  --> nao identificado
;
; DPMADDR   = tamanho da memoria de programa em bytes.
; DDMADDR   = tamanho da EEPROM em bytes.
;
; ----------------------------------------------------------------------
retrydet       equ     .8
chip_detect 
chipDetect

  ifdef LCD_REQUIRED
               call    SR_LCDCLEAR
               call    msgDetect
               movlw   retrydet
               movwf   R8
  endif

chipDetect1

  ifdef LCD_REQUIRED
               movlw   "."
               call    SR_SENDW
  endif

               movlw   pgrbuff
               call    picReadConfig

               movlw   pgrbuff
               addlw   .13
               movwf   FSR
               movf    INDF, w              ; MSB do Device ID
               movwf   R11
               decf    FSR, f               ; retrocede
               movf    INDF, w              ; LSB do Device ID
               movwf   R10

               movlw   .5
               movwf   R9
_rrfr10        rrf     R11, f
               rrf     R10, f
               decfsz  R9, f
               goto    _rrfr10

               movf    R10, w               ; pega o ID
               movwf   microchip            ; salva microcontrolador detectado

               movf    microchip, w
               xorlw   PIC16F627A
               btfss   STATUS, Z
               goto    chip_detec02
               movlw   high(.1024)
               movwf   DPMADDR
               movlw   low(.1024)
               movwf   DPMADDR+.1   
               movlw   .128
               movwf   DDMADDR  
               goto    chip_isgood

chip_detec02   movf    microchip, w
               xorlw   PIC16F628A
               btfss   STATUS, Z
               goto    chip_detec03
               movlw   high(.2048)
               movwf   DPMADDR
               movlw   low(.2048)
               movwf   DPMADDR+.1       
               movlw   .128
               movwf   DDMADDR     
               goto    chip_isgood

chip_detec03   movf    microchip, w
               xorlw   PIC16F648A
               btfss   STATUS, Z
               goto    chip_detec04
               movlw   high(.4096)
               movwf   DPMADDR
               movlw   low(.4096)
               movwf   DPMADDR+.1    
               movlw   .255
               movwf   DDMADDR 
               goto    chip_isgood

chip_detec04   movf    microchip, w
               xorlw   PIC16F688
               btfss   STATUS, Z
               goto    chip_detec05
               movlw   high(.4096)
               movwf   DPMADDR
               movlw   low(.4096)
               movwf   DPMADDR+.1    
               movlw   .255
               movwf   DDMADDR 
               goto    chip_isgood

chip_detec05   movf    microchip, w
               xorlw   PIC12F675
               btfss   STATUS, Z
               goto    chip_detec999
               movlw   high(.1024)
               movwf   DPMADDR
               movlw   low(.1024)
               movwf   DPMADDR+.1    
               movlw   .128
               movwf   DDMADDR 
               goto    chip_isgood


chip_detec999  TEMPO   .1
               decfsz  R8, f                ; retry
               goto    chipDetect1

               
  ifdef LCD_REQUIRED
               call    SR_LCDCLEAR
               call    msgErro
               goto    chip_nogood
  endif  
               return

chip_isgood
  ifdef LCD_REQUIRED
               call    SR_LCDCLEAR
               call    msgOk
               movlw   " "
               call    SR_SENDW
chip_nogood    call    msgChip
               movf    microchip, w
               call    lcdHexa
               TEMPO   .1
  endif  
               return
