; ----------------------------------------------------------------------------------------------
; LEITURA DA MEMORIA DE CONFIGURACAO                                                  05/08/2020
;
; STATUS: FUNCIONA
;
; Le o conteudo da memoria de configuracao nos enderecos 0x2000 a 0x2007 cujo layout e':
;
;                     2000 2001 2002 2003 2004 2005 2006 2007
;                     UUuu:UUuu:UUuu:UUuu:RRrr:RRrr:DDdd:WWww 
; onde
;
; UUuu ......... User ID
; RRrr ......... Reserved
; DDdd ......... Device ID
; WWww ......... Configuration Word
;
; O Device-ID podera ser:
;   01.0000.010 --> PIC16F627A
;   01.0000.011 --> PIC16F628A
;   01.0001.000 --> PIC16F648A
; ----------------------------------------------------------------------------------------------

chip_rdcm      movlw   pgrbuff
               call    picReadConfig

               ; Pega USERID+0
               movlw   pgrbuff+.1
               call    getPgrByte
               call    serialPut
               movlw   pgrbuff+.0
               call    getPgrByte
               call    serialPut

               ; Pega USERID+1
               movlw   pgrbuff+.3
               call    getPgrByte
               call    serialPut
               movlw   pgrbuff+.2
               call    getPgrByte
               call    serialPut

               ; Pega USERID+2
               movlw   pgrbuff+.5
               call    getPgrByte
               call    serialPut
               movlw   pgrbuff+.4
               call    getPgrByte
               call    serialPut

               ; Pega USERID+3
               movlw   pgrbuff+.7
               call    getPgrByte
               call    serialPut
               movlw   pgrbuff+.6
               call    getPgrByte
               call    serialPut

               ; Pega Device ID
               movlw   pgrbuff+.13
               call    getPgrByte
               call    serialPut
               movlw   pgrbuff+.12
               call    getPgrByte
               call    serialPut

               ; Pega Configuration Word
               movlw   pgrbuff+.15
               call    getPgrByte
               call    serialPut
               movlw   pgrbuff+.14
               call    getPgrByte
               call    serialPut
               goto    0x00

getPgrByte     movwf   FSR
               movf    INDF, w
               return
