
    ifdef LCD_REQUIRED

printHeader    call    SR_LCDCLEAR
               movlw   pgrbuff
               movwf   FSR
               movlw   .4
               movwf   R5
printHead2     movf    INDF, w
               incf    FSR, f
               call    lcdHexa
               decfsz  R5, f
               goto    printHead2

               SET_CURSOR .2, .1, "i"
               movlw   dataLen
               movwf   FSR
               movlw   .4
               movwf   R5
printHead3     movf    INDF, w
               incf    FSR, f
               call    lcdHexa
               decfsz  R5, f
               goto    printHead3

               call    waitStep

               return
 endif

















; ------------------------------------------------------------------------
; printLine - DEBUG                                             31/07/2020
;
; Mostra a linha de programa recebida do PC.
;
; Enrtrada: FSR aponta o inicio do buffer
; Saida   : Nao ha
; ------------------------------------------------------------------------
printLine 

  ifdef LCD_REQUIRED
               movwf   FSR
               call    SR_LCDCLEAR
               movlw   .8
               movwf   R3
printLine2     movf    INDF, w
               incf    FSR, f
               call    lcdHexa
               decfsz  R3, f
               goto    printLine2
               SET_CURSOR .2, .1, "i"
               movlw   .8
               movwf   R3
printLine3     movf    INDF, w
               incf    FSR, f
               call    lcdHexa
               decfsz  R3, f
               goto    printLine3
               call    waitStep
               return
  endif


; ------------------------------------------------------------------------
; waitStep - DEBUG                                              31/07/2020
;
; Aguarda um botao ser pressionado para continuar o processamento.
; ------------------------------------------------------------------------
#define        steptris TRISB
#define        stepport PORTB
#define        stepbit  .0
waitStep
  ifdef LCD_REQUIRED
               bsf     STATUS, RP0
               bsf     steptris, stepbit
               bcf     STATUS, RP0   
               movf    stepport, w
               movwf   R0
               movlw   .80
               call    delay_ms
               btfsc   R0, stepbit 
               goto    waitStep 
  endif
               return


  
; ------------------------------------------------------------------------
; Mostra somente o ultimo dado resgatado do buffer              31/07/2020
; e o CRC
;
; Entrada: W aponta para o buffer desejado no formato BBAAaaTTDD....DDCR
;
; ------------------------------------------------------------------------
printData  
    ifdef LCD_REQUIRED
               movwf   R0                  ; endereco do inicio do buffer (BB)
               call    SR_LCDCLEAR 
               SET_CURSOR .1, .1, "i"
               movf    R0, w               ; restaura endereco de BB
               movwf   FSR                 ; carrega indexador
               movf    INDF, w             ; pega o tamanho (BB)
               movwf   R1                  ; salva o tamanho
               movf    R0, w               ; restaura endereco do inicio  
               addlw   .4                  ; aponta para os dados
               addwf   R1, w               ; endereco dos dados + tamanho

               movwf   FSR
               decf    FSR, f
               decf    FSR, f

               movf    INDF, w
               incf    FSR, f
               call    lcdHexa

               movf    INDF, w
               incf    FSR, f
               call    lcdHexa

               movlw   "."
               call    SR_SENDW

               movf    INDF, w
               incf    FSR, f
               call    lcdHexa

               call    waitStep
  endif
printData99    return





