
; ---------------------------------------------------------------------------
; crc_match                                                        29/07/2020
;    
; Verifica o CRC da linha de programa enviada pelo PC.
;
; Entrada: Nao ha
; Saida  : W=0 --> CRC valido
;          W=1 --> CRC invalido
; ---------------------------------------------------------------------------
crcMatch
  ifdef _CHECK_SUM
    messg "CRC SERA VERIFICADO"
               movf    dataLen, w             ; pega o tamanho
               movwf   R2                     ; carrega o contador
               addwf   dataH, w               ;      W = dataLen + dataH
               addwf   dataL, w               ;      W = dataLen + dataH + dataL
               addwf   dataType, w            ;      W = dataLen + dataH + dataL + dataType
               movwf   crcalc                 ; crcalc = dataLen + dataH + dataL + dataType
               movlw   dataBytes              ; endereco de dataBytes
               movwf   FSR                    ; carrega indexador
               movf    dataLen, w             ; pega o tamanho dos dados
               xorlw   0x00                   ; verifica o tamanho
               btfsc   STATUS, Z              ; tem dados na linha???
               goto    crc_match3             ; NAO --> entao nao soma
               movf    crcalc, w              ;  W = dataLen + dataH + dataL + dataType
crc_match2     addwf   INDF, w                ;  W = dataLen + dataH + dataL + dataType + dataBytes + ...
               incf    FSR, f                 ; proximo dataBytes
               decfsz  R2, f                  ; fim dos dataBytes ???
               goto    crc_match2             ; NAO -->
               movwf   crcalc                 ; crcalc = dataLen + dataH + dataL + dataType + (N * dataBytes)
crc_match3     movf    INDF, w                ; pega CRC recebido
               movwf   crrec                  ; salva CRC recebido
               comf    crcalc, f              ; crcalc = complemento da soma
               movlw   .1
               addwf   crcalc, f              ; soma 1 no complemento
               movf    crcalc, w
               xorwf   crrec, w               ; W = calculado : recebido
               return                         ; retorna resultado em W
  else
    messg "CRC NAO SERA VERIFICADO"
               retlw   .0                     ; retorna sempre certo
  endif
