; ---------------------------------------------------------------------------
; dataRecovery                                                     26/07/2020
;    
; Recupera os dados do buffer de leitura da porta serial e armazena nos
; registradores 'dataLen', 'dataH', 'dataL', 'dadaType' e 'dataBytes'.
;
; Entrada: 'pgrbuff' deve ter sido preenchido pela leitura da porta serial.
; Saida  : 'dataLen', 'dataH', 'dataL', 'dadaType' e 'dataBytes' preenchidos
;          com os dados do buffer de leitura da porta serial.
; ---------------------------------------------------------------------------
dataRecovery   movlw   pgrbuff                   ; inicio do buffer

               movwf   FSR                       ; aponta o tamanho
               movf    INDF, w                   ; pega o tamanho
               movwf   dataLen                   ; salva

               incf    FSR, f                    ; aponta low address
               movf    INDF, w                   ; pega low address
               movwf   dataH                     ; salva

               incf    FSR, f                    ; aponta high address
               movf    INDF, w                   ; pega high address
               movwf   dataL                     ; salva

               incf    FSR, f                    ; aponta tipo
               movf    INDF, w                   ; pega tipo
               movwf   dataType                  ; salva

               incf    FSR, f                    ; oponta primeiro dado no buffer
               movf    FSR, w                    ; pega apontador de dados no buffer
               movwf   ptrBuff                   ; salva apontador do buffer no banco 1

               movlw   dataBytes                 ; endereco dos dados no banco 0 (dataBytes)
               movwf   ptrBytes                  ; salva ponteiro de dados no banco 0

               movf    dataLen, w                ; pega o tamanho dos dados
               movwf   R5                        ; carrega contador
               incf    R5, f                     ; um a mais para poder pegar o CRC
 
               ; Pega um dado no buffer (banco 1) e aponta para o proximo
datarec2       movf    ptrBuff, w                ; endereco atual no buffer
               movwf   FSR                       ; carrega indexador
               movf    INDF, w                   ; pega um dado no buffer
               movwf   R7                        ; salva temporariamente
               incf    FSR, f                    ; avanca proximo endereco no buffer
               movf    FSR, w                    ; pega proximo endereco no buffer
               movwf   ptrBuff                   ; salva apontador de dados do buffer

               ; Move o dado para o banco 0 e aponta para o proximo
               movf    ptrBytes, w               ; pega apontador atual no banco 0
               movwf   FSR                       ; carrega indexador
               movf    R7, w                     ; pega o dado vindo do buffer
               movwf   INDF                      ; salva o dado no programa
               incf    FSR, f                    ; proximo dado no programa
               movf    FSR, w                    ; pega proximo endereco de dado no programa
               movwf   ptrBytes                  ; salva proximo local de dado no banco 0

               decfsz  R5, f                     ; fim dos dados no buffer???
               goto    datarec2                  ; NAO --> vai pegar dado

               return
