; ------------------------------------------------------------------------
; pgmVerify                                                     31/07/2020
;
; STATUS: FUNCIONA
;
; Verifica a gravacao de um byte na memoria de programa.
;
; Este codigo sera gerado apenas se o simbolo '_VERIFY' estiver definido.
;
; Se o simbolo '_VERIFY' nao for definido este codigo nao sera gerado e a
; verificacao nao sera realizada. Nesta caso, sera retornado sempre 
; W=0 indicando que esta' ok.
;
; Entrada: Nao ha
; Saida  : W = 0 ---> OK
;          W = 1 ---> Erro
; ------------------------------------------------------------------------
pgmVerify 
  ifdef _VERIFY
  messg "VERIFICACAO DE GRAVACAO SERA REALIZADA"

         call   picReadPgm
  
  ifdef  LCD_REQUIRED
         SET_CURSOR .1, .1, "i"
         movlw  "R"
         call   SR_SENDW
         movlw  ":"
         call   SR_SENDW
         movf   bkp1, w               ; MSB original
         call   lcdHexa
         movf   bkp0, w               ; LSB original 
         call   lcdHexa

         SET_CURSOR .1, .11, "i"
         movlw  "G"
         call   SR_SENDW
         movlw  ":"
         call   SR_SENDW
         movf   pgmr_data1, w          ; MSB lido apos gravacao
         call   lcdHexa
         movf   pgmr_data0, w          ; LSB lido apos garavacao
         call   lcdHexa

 endif
         movf   bkp0, w
         xorwf  pgmr_data0, w
         btfss  STATUS, Z
         retlw  .1                ; errado

         movf   bkp1, w
         xorwf  pgmr_data1, w
         btfss  STATUS, Z
         retlw  .1                ; errado
         retlw  .0                ; certo

  else
     messg "VERIFICACAO DE GRAVACAO NAO SERA REALIZADA"
         retlw  .0                ; retorna sempre certo
  endif




               return
